<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelCupomPromo  {

    protected $relCupomPromoService;
    protected $utilService;
    
    public function __construct(Services\RelCupomPromoService $relCupomPromoService, Utilities\Util $utilService) {
        $this->relCupomPromoService = $relCupomPromoService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->conditionsMake($conditions);
        
        if(isset($conditions['CDFILIAL'])) {
            $result = $this->relCupomPromoService->find($conditions);
        }
        
        $response->addDataSet(new DataSet("orm00030_relCupomPromo", $result));
    }
    
    public function conditionsMake(&$conditions){
        if (isset($conditions['CDFILIAL'])){
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        }
        
        if (isset($conditions['CDCUPOMDESCFOS'])){
            $conditions['CDCUPOMDESCFOS'] = implode('_', $conditions['CDCUPOMDESCFOS']);
            $conditions['TCDCUPOMDESCFOS'] = null;
        }
        else {
            $conditions['CDCUPOMDESCFOS'] = null;
            $conditions['TCDCUPOMDESCFOS'] = 'T';
        }
        
        if (isset($conditions['CDLOJA'])){
            if(is_array($conditions['CDLOJA'])){
                $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
                $conditions['TCDLOJA'] = null;
            }
            else {
                $conditions['CDLOJA'] = null;
                $conditions['TCDLOJA'] = 'T';
            }
        }
        else {
            $conditions['CDLOJA'] = null;
            $conditions['TCDLOJA'] = 'T';
        }
        
        if (isset($conditions['DTENTRVENDA'])){
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
        }
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        $conditions['NRORG'] = $conditions['NRORG'];

    }
}